import os
import gc
import sys
import weakref
import gtk


class G(object):
    def __init__(self, title=''):
        self.windows = []
        self.objects = []
        self.title = title
        self.w = gtk.Window()
        self.w.set_title(title)
        self.h = gtk.HBox()
        self.kill_button = gtk.Button("kill")
        self.crea_button = gtk.Button(title and "Finestra %s" % title or "crea %s finestre" % n)
        self.w.add(self.h)
        self.h.add(self.crea_button)
        self.h.add(self.kill_button)
        self.w.show_all()
        self.w.connect('delete-event', self.delete_event_cb)
        self.kill_button.connect('clicked', self.clicked_cb)
        self.crea_button.connect('clicked', self.crea_molte_finestre)

    def delete_event_cb(self, win, ev=None):
        self.w.get_toplevel().destroy()
        del self.w

    def crea_molte_finestre(self, win, ev=None):
        if self.title:
            return
        for i in range(n):
            #r = G(title=str(i))
            obj = G(title=str(i))
            r = weakref.ref(obj)
            self.windows += [r]
            self.objects.append(obj)

    def clicked_cb(self, win):
        if self.title:
            self.delete_event_cb(win)
        else:
            for g in self.windows:
                if g():
                    g().delete_event_cb(None, None)
                #if g:  # se non usi weakref
                #    g.delete_event_cb(None, None)
            self.windows = []
            del self.objects[:]


if __name__ == '__main__' :

    if len(sys.argv) == 2:
        n = int(sys.argv[1])
    else:
        n = 10
    obj = G()
    obj.w.connect('destroy', gtk.main_quit)
    try:
        gtk.main()
    except KeyboardInterrupt:
        sys.exit()
